// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "CustomBrush.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	ON_WM_MEASUREITEM()
	ON_WM_DRAWITEM() 
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
//	pView=new CCustomBrushView();
}
CMainFrame::~CMainFrame() 
{
//	delete pView;

}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	CMenu *pMenu=GetMenu();
	for(int i=2;i<7;i++)
		pMenu->ModifyMenu(ID_BRUSH_NONE+i,MF_OWNERDRAW,ID_BRUSH_NONE+i);
 
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnMeasureItem( int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct )
{

	lpMeasureItemStruct->itemHeight=::GetSystemMetrics(SM_CYMENU)+ 3; 
  lpMeasureItemStruct->itemWidth=::GetSystemMetrics(SM_CYMENU) * 5 + 5;

}
void DrawMyOwnMenu(CDC *pDC,CRect &rect,int &itemID);
void DrawWhenSelected(CDC *pDC,CRect &rect,int &itemID);


void CMainFrame::OnDrawItem( int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct )
{
	int itemID=lpDrawItemStruct->itemID;
	CRect rect=lpDrawItemStruct->rcItem;
	CDC *pDC=CDC::FromHandle(lpDrawItemStruct->hDC);
	DrawMyOwnMenu(pDC,rect,itemID);
	
	if(lpDrawItemStruct->itemState & ODS_SELECTED)
	{
	CBrush brush,*pOldBrush;
	brush.CreateSolidBrush(RGB(0,0,127));
	pOldBrush=pDC->SelectObject(&brush);
	pDC->FillRect(&(lpDrawItemStruct->rcItem),&brush);
	pDC->SelectObject(pOldBrush);
	brush.DeleteObject();
	//DrawSelectedMenuRect(nIDCtl1,rect,dc); 
   DrawWhenSelected(pDC,rect,itemID);
	}
	else
	{
	CBrush brush,*pOldBrush;
	brush.CreateSolidBrush(RGB(191,191,191));
	pOldBrush=pDC->SelectObject(&brush);
	pDC->FillRect(&(lpDrawItemStruct->rcItem),&brush);
	pDC->SelectObject(pOldBrush);
	brush.DeleteObject();;
	DrawMyOwnMenu(pDC,rect,itemID);

}

}
void SimpleCode(CDC *pDC,CBrush &brush,CRect rect);

void DrawMyOwnMenu(CDC *pDC,CRect &rect,int &itemID)
{
	CCustomBrushView *pView=new CCustomBrushView();

	CBrush brush;
	int x1,x2,y1,y2;
	x1=rect.left;
    y1=rect.top;
	x2=rect.right;
	y2=rect.bottom;
	CRect rect1(x1 + 18,y1 +1,x2 - 18,y2 -2);
	switch(itemID)
	{
	case ID_BRUSH_SQUARE:

		 pView->CreateCustomBrush(RGB(0,0,0),1,brush,pDC);
		 SimpleCode(pDC,brush,rect1);
		 break;
 	case ID_BRUSH_CIRCLE:
         pView->CreateCustomBrush(RGB(0,0,0),2,brush,pDC);
		  SimpleCode(pDC,brush,rect1);
		  break;

    case ID_BRUSH_DOTINCIRCLE:
	     pView->CreateCustomBrush(RGB(0,0,0),3,brush,pDC);
	  	 SimpleCode(pDC,brush,rect1);
		 break;
   case ID_BRUSH_DOTINSQARE:
	     pView->CreateCustomBrush(RGB(0,0,0),4,brush,pDC);
		 SimpleCode(pDC,brush,rect1);
		 break;
  case ID_BRUSH_DOTS:
	     pView->CreateCustomBrush(RGB(0,0,0),5,brush,pDC);
		 SimpleCode(pDC,brush,rect1);
		 break;

		
	}
	
	delete pView;
	return;
}
void DrawWhenSelected(CDC *pDC,CRect &rect,int &itemID)
{
	CCustomBrushView *pView=new CCustomBrushView();

  CBrush brush;
	int x1,x2,y1,y2;
	x1=rect.left;
    y1=rect.top;
	x2=rect.right;
	y2=rect.bottom;
  CRect rect2(x1 + 18,y1 +1,x2 - 18,y2 -2);
        
  pDC->FillSolidRect(&rect2,RGB(0,0,0));
	
	switch(itemID)
	{
	case ID_BRUSH_SQUARE:
	    
		  pView->CreateCustomBrush(RGB(255,255,255),1,brush,pDC);
		  SimpleCode(pDC,brush,rect2);
		 break;
	
	case ID_BRUSH_CIRCLE:
	   // // letter
	  	pView->CreateCustomBrush(RGB(255,255,255),2,brush,pDC);
		 SimpleCode(pDC,brush,rect2);
		 break;
    case ID_BRUSH_DOTINCIRCLE:
	     pView->CreateCustomBrush(RGB(255,255,255),3,brush,pDC);
		 SimpleCode(pDC,brush,rect2);
		 break;
   case ID_BRUSH_DOTINSQARE:
	   pView->CreateCustomBrush(RGB(255,255,255),4,brush,pDC);
		 SimpleCode(pDC,brush,rect2);
		 break;
   case ID_BRUSH_DOTS:
	    pView->CreateCustomBrush(RGB(255,255,255),5,brush,pDC);
		 SimpleCode(pDC,brush,rect2);
		 break;


	}

    delete pView;
	return;
}


void SimpleCode(CDC *pDC,CBrush &brush,CRect rect)
{ 
	         CBrush *oldbrush;
			 oldbrush=pDC->SelectObject(&brush);
            pDC->Rectangle(rect);
		    pDC->SelectObject(oldbrush);
		    brush.DeleteObject();
			return;
	
	}




//	 oldbrush=pDC->SelectObject(&brush);
     //    pDC->Rectangle(x1 + 18,y1 +1,x2 - 18,y2 -2);
	//	 pDC->SelectObject(oldbrush);
	//	 brush.DeleteObject();
	
